<id>
MyCenter customLink Y2.2
</id>

<version>
1 beta
</version>

<mod info>
-------------------------------------------
Intructions
-------------------------------------------

1. open mod in notpad 
   
   search for:
   My Extended Profile Fields

   replace with:
   anything you want (example:  My Media or My Images)

2. install the mod

3. use extended profiles mod and create fields

4. upload to Admin/
   ModList.pl

    upload to Sources/
   
   ExtendedProfiles.pl 
   MyCenter.pl
   Profile.pl
   SubList.pl

    upload to Languages/English/

   ExtendedProfiles.lng
</mod info>

<author>
TimothyDFirman
</author>

<homepage>

</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$customLink = "MyCenter customLink Mod Y2.2|TimothyDFirman|MyCenter customLink Y2.2|0.01 BETA|07-01-08";
	push (@installed_mods, $customLink);
</add before>

<edit file>
Sources/ExtendedProfiles.pl
</edit file>

<search for>
					qq~  <option value="4"$editable_check[4]>$lang_ext{'page_im'}</option>\n~.
</search for>

<add after>
					qq~  <option value="5"$editable_check[5]>$lang_ext{'page_customLink'}</option>\n~.
</add after>

<search for>
		   (($part eq "im")         && ($field{'editable_by_user'} == 4)))) { # im prefs page
</search for>

<replace>
		   (($part eq "im")         && ($field{'editable_by_user'} == 4)) ||  # im prefs page
		   (($part eq "customLink")       && ($field{'editable_by_user'} == 5)))) { # customLink prefs page
</replace>

<edit file>
Sources/MyCenter.pl
</edit file>

<search for>
&LoadLanguage('MyCenter');
</search for>

<add after>
&LoadLanguage('ExtendedProfiles');
</add after>

<search for>
		elsif ($action eq 'myviewprofile') { &ViewProfile; }
</search for>

<add before>
		elsif ($action eq 'mycustomLink') { &customLink; }
		elsif ($action eq 'mycustomLink2') { &customLink2; }
</add before>

<search for>
	if ($PM_level == 1 || ($PM_level == 2 && ($iamadmin || $iamgmod || $iammod)) || ($PM_level == 3 && ($iamadmin || $iamgmod))) {
		$thisLink = $profileLink . 'myprofileIM;username=' . $useraccount{$username} . $sidLink;
		$MCProfMenu .= qq~
		<span class="nav"><b><a href="$scripturl?$thisLink">$inmes_txt{'765'}</a></b></span>
		<br />
		~;
	}
</search for>

<add after>
	$thisLink = $profileLink . 'mycustomLink;username=' . $useraccount{$username} . $sidLink;
	$MCProfMenu .= qq~
        <span class="nav"><b><a href="$scripturl?$thisLink">$lang_ext{'customLink'}</a></b></span><br />~;
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
&LoadLanguage('Profile');
</search for>

<add after>
&LoadLanguage('ExtendedProfiles');
</add after>

<search for>
	@menucolors = qw(catbg catbg catbg catbg catbg catbg);
</search for>

<replace>
	@menucolors = qw(catbg catbg catbg catbg catbg catbg catbg);
</replace>

<search for>
	if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
		$yymain .= qq~
			<td class="$menucolors[5]" valign="bottom" width="16%" align="center"><span class="small"><b><a href="$scripturl?action=profileAdmin;username=$useraccount{$user};sid=$INFO{'sid'}">$profile_txt{820}</a></b></span></td>~;
	}
	$yymain .= qq~
</search for>

<replace>
	$yymain .= qq~
			<td class="$menucolors[5]" valign="bottom" width="16%" align="center"><span class="small"><b><a href="$scripturl?action=customLink;username=$useraccount{$user};sid=$INFO{'sid'}">$lang_ext{'customLink'}</a></b></span></td>~;

	if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
		$yymain .= qq~
			<td class="$menucolors[6]" valign="bottom" width="16%" align="center"><span class="small"><b><a href="$scripturl?action=profileAdmin;username=$useraccount{$user};sid=$INFO{'sid'}">$profile_txt{820}</a></b></span></td>~;
	}
	$yymain .= qq~
</replace>

<search for>
sub ModifyProfileAdmin {
	&SidCheck($action);

	&is_admin_or_gmod;
	&PrepareProfile;

	my $user = $INFO{'username'};
	if (!${$uid.$user}{'password'}) { &LoadUser($user); }

	$menucolors[5] = "titlebg";
	if (!$view) { &ProfileMenu; }
</search for>

<replace>
sub customLink {
	&SidCheck($action);

	&PrepareProfile;
	my $user = $INFO{'username'};
	if (!${$uid.$user}{'password'}) { &LoadUser($user); }
	$menucolors[5] = "titlebg";
	if (!$view) { &ProfileMenu; }

	my $scriptAction = qq~customLink2~;
	if ($view)	{ 
		$scriptAction = qq~mycustomLink2~;
		$yytitle = qq~$profile_txt{'editmyprofile'} &rsaquo; $profile_txt{'819'}~;
		$profiletitle = qq~$profile_txt{'editmyprofile'} ($user) &rsaquo; My Extended Profile Fields~;
		$yynavigation = qq~&rsaquo; <a href="$scripturl?action=mycenter" class="nav">$img_txt{'mycenter'}</a> &rsaquo; $profiletitle~;
	} else {
		$yytitle = qq~$profile_txt{'79'} &rsaquo; $profile_txt{'819'}~;
		$profiletitle = qq~$profile_txt{'79'} ($user) &rsaquo; $lang_ext{'customLink'}~;
		$yynavigation = qq~&rsaquo; $profiletitle~;
	}

	$showProfile .= qq~
<form action="$scripturl?action=$scriptAction;username=$useraccount{$INFO{'username'}};sid=$INFO{'sid'}" method="post" name="creator" onsubmit="javascript: selectblNames();">
<table cellspacing="1" cellpadding="4" width="100%" align="center" class="bordercolor" border="0">
  <tr>
    <td colspan="2" class="catbg"><img src="$imagesdir/profile.gif" alt="" border="0" /> <b>$profiletitle</b></td>
  </tr>~;

   require "$sourcedir/ExtendedProfiles.pl";
   $showProfile .= ext_editprofile($user,"customLink");
   $showProfile .= qq~
      <tr class="catbg">
     <td height="30" valign="middle" align="center" colspan="2"><input type="submit" name="moda" value="$profile_txt{'88'}" class="button" /></td>
   </tr>
</table>
</form>
~;

		if (!$view) {
		$yymain .= $showProfile;
		&template;
		exit;
	}
}

sub ModifyProfileAdmin {
	&SidCheck($action);

	&is_admin_or_gmod;
	&PrepareProfile;

	my $user = $INFO{'username'};
	if (!${$uid.$user}{'password'}) { &LoadUser($user); }

	$menucolors[6] = "titlebg";
	if (!$view) { &ProfileMenu; }
</replace>

<search for>
	&UserAccount($user, "update");

	my $scriptAction = qq~viewprofile~;
	if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
		$scriptAction = qq~profileAdmin~;
	}
	if ($view)	{ $scriptAction = qq~my~ . $scriptAction; }
	$yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
	&redirectexit;
}
</search for>

<replace>
	&UserAccount($user, "update");	
	
	my $scriptAction = qq~customLink~;
	if ($view)	{ $scriptAction = qq~my~ . $scriptAction; }
	$yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
	&redirectexit;
}

sub customLink2 {
	&SidCheck($action);

	my (%member, $key, $value, $tempname);
	while (($key, $value) = each(%FORM)) {
		$value =~ s~\A\s+~~;
		$value =~ s~\s+\Z~~;
		$value =~ s~[\n\r]~~g;
		$member{$key} = $value;
	}
	
	my $user = $INFO{'username'};
	$member{'username'} = $user;
	if (!${$uid.$user}{'password'}) { &LoadUser($user); }
	
	# make sure this person has access to this profile
	if ($user ne $username && !$iamadmin && (!$iamgmod || !$allow_gmod_profile)) { &fatal_error("not_allowed_profile_change"); }
	
    # let's restore the name now
		$member{'name'} = $tempname;
                
		require "$sourcedir/ExtendedProfiles.pl";
		my $error = ext_validate_submition($username,$user);
		if ($error ne "") { &fatal_error("extended_profiles_validation",$error); } else { &ext_saveprofile($user); }
		
	&UserAccount($user, "update");

	my $scriptAction = qq~viewprofile~;
	if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
		$scriptAction = qq~profileAdmin~;
	}
	if ($view)	{ $scriptAction = qq~my~ . $scriptAction; }
	$yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
	&redirectexit;
}
</replace>

<search for>
	# End statistics.
	if (${$uid.$user}{'usertext'}) {
		$wrapcut = 20;
		$wrapstr = ${$uid.$user}{'usertext'};
		&WrapChars;
		$showusertext = $wrapstr;
		$showusertext =~ s/<br \/>/ /g;
	}
</search for>

<add after>
	$showProfile .= qq~
<table border="0" cellpadding="8" cellspacing="1" class="bordercolor" align="center" width="100%">
	<tr>
		<td class="windowbg2" width="40%" align="center" valign="top">	~;

</add after>

<search for>
	if (${$uid.$user}{'postcount'} > 0 && $maxrecentdisplay > 0 && !$view) {
		$showProfile .= qq~
	<tr>
	<td class="windowbg2" align="left">
		<form action="$scripturl?action=usersrecentposts;username=$useraccount{$user}" method="post">
		$profile_txt{'460'} <select name="viewscount" size="1">
		<option value="5" selected="selected">5</option>
		<option value="10">10</option>
		<option value="15">15</option>
		<option value="$maxrecentdisplay">$maxrecentdisplay</option>
		</select> $profile_txt{'461'} ${$uid.$user}{'realname'}.
		<input type="submit" value="$profile_txt{'462'}" class="button" />
		</form>
	</td>
	</tr>
~;
	}
	$showProfile .= qq~
</table>
<script language="JavaScript1.2" type="text/javascript">
<!--
</search for>

<replace>
		$showProfile .= qq~
</table></td><td class="windowbg2" width="60%" align="center" valign="top">
<table border="0" cellpadding="8" cellspacing="1" class="bordercolor" align="center" width="100%">
	<tr>
		<td class="catbg" align="left">
			<img src="$imagesdir/profile.gif" alt="" border="0" style="vertical-align: middle;" />&nbsp;
			<span class="text1"><b>$lang_ext{'customLink'}</b></span>
		</td>
	</tr>
	<tr>
	~;
		
	require "$sourcedir/ExtendedProfiles.pl";
	$showProfile .= ext_viewprofile($user);	
	$showProfile .= qq~
</tr></table></td></tr>
	~;
	if (${$uid.$user}{'postcount'} > 0 && $maxrecentdisplay > 0 && !$view) {
		$showProfile .= qq~
	<tr>
	<td class="windowbg2" align="left" colspan="2">
		<form action="$scripturl?action=usersrecentposts;username=$useraccount{$user}" method="post">
		$profile_txt{'460'} <select name="viewscount" size="1">
		<option value="5" selected="selected">5</option>
		<option value="10">10</option>
		<option value="15">15</option>
		<option value="$maxrecentdisplay">$maxrecentdisplay</option>
		</select> $profile_txt{'461'} ${$uid.$user}{'realname'}.
		<input type="submit" value="$profile_txt{'462'}" class="button" />
		</form>
	</td>
	</tr></table>
~;
	}
	$showProfile .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
</replace>

<search for>
	if ($row_gender || $row_age || $row_location) {
		$showProfile .= qq~
	<tr>
		<td class="windowbg2" align="left" valign="top">
		$row_gender
		$row_age
		$row_location
		</td>
	</tr>
	~;
	}
	require "$sourcedir/ExtendedProfiles.pl";
	$showProfile .= ext_viewprofile($user);
	$showProfile .= qq~
	<tr>
		<td class="catbg" align="left">
			<img src="$imagesdir/profile.gif" alt="" border="0" style="vertical-align: middle;" />&nbsp;
			<span class="text1"><b>$profile_txt{'819'}</b></span>
		</td>
	</tr>
	<tr>
		<td class="windowbg2" align="left">
		~;
	}

</search for>

<replace>
	if ($row_gender || $row_age || $row_location) {
		$showProfile .= qq~
	<tr>
		<td class="windowbg2" align="left" valign="top">
		$row_gender
		$row_age
		$row_location
		</td>
	</tr>
	<tr>
		<td class="catbg" align="left">
			<img src="$imagesdir/profile.gif" alt="" border="0" style="vertical-align: middle;" />&nbsp;
			<span class="text1"><b>$profile_txt{'819'}</b></span>
		</td>
	</tr>
	<tr>
		<td class="windowbg2" align="left">
		~;
	}
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'myprofileIM2',"MyCenter.pl&mycenter",
</search for>

<add after>
'customLink',"Profile.pl&customLink",
'mycustomLink',"MyCenter.pl&mycenter",
'customLink2',"Profile.pl&customLink2",
'mycustomLink2',"MyCenter.pl&mycenter",
</add after>

<edit file>
Languages/English/ExtendedProfiles.lng
</edit file>

<search for>
'page_im' => "User can edit it, show on \"IM Preferences\" page",
</search for>

<add after>
'page_customLink' => "User can edit it, show on \"customLink\" page",
'customLink' => "My Extended Profile Fields",
</add after>